/*
 * #%L
 * JavaHg
 * %%
 * Copyright (C) 2011 aragost Trifork ag
 * %%
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 * #L%
 */

/*
 * Automatically generated based on Mercurial 2.1.1+41-63a1bed65fa3.
 *
 * Don't edit this file! Edit scripts/generate-flag-classes.py instead.
 */
package com.aragost.javahg.ext.mq.flags;

import com.aragost.javahg.Repository;
import com.aragost.javahg.ext.mq.QDiffCommand;
import com.aragost.javahg.internals.AbstractCommand;

public abstract class QDiffCommandFlags extends AbstractCommand {

    protected QDiffCommandFlags(Repository repository) {
        super(repository);
    }

    @Override
    public final String getCommandName() {
        return "qdiff";
    }

    public static QDiffCommand on(Repository repository) {
        return new QDiffCommand(repository);
    }

    /**
     * Set the <tt>--text</tt> command line flag.
     * 
     * @see <a
     *      href="http://www.selenic.com/mercurial/hg.1.html#qdiff">Mercurial
     *      documentation</a>
     * @return this instance
     */
    public QDiffCommand text() {
        cmdAppend("--text");
        return (QDiffCommand) this;
    }

    /**
     * Set the <tt>--nodates</tt> command line flag.
     * 
     * @see <a
     *      href="http://www.selenic.com/mercurial/hg.1.html#qdiff">Mercurial
     *      documentation</a>
     * @return this instance
     */
    public QDiffCommand nodates() {
        cmdAppend("--nodates");
        return (QDiffCommand) this;
    }

    /**
     * Set the <tt>--show-function</tt> command line flag.
     * 
     * @see <a
     *      href="http://www.selenic.com/mercurial/hg.1.html#qdiff">Mercurial
     *      documentation</a>
     * @return this instance
     */
    public QDiffCommand showFunction() {
        cmdAppend("--show-function");
        return (QDiffCommand) this;
    }

    /**
     * Set the <tt>--reverse</tt> command line flag.
     * 
     * @see <a
     *      href="http://www.selenic.com/mercurial/hg.1.html#qdiff">Mercurial
     *      documentation</a>
     * @return this instance
     */
    public QDiffCommand reverse() {
        cmdAppend("--reverse");
        return (QDiffCommand) this;
    }

    /**
     * Set the <tt>--ignore-all-space</tt> command line flag.
     * 
     * @see <a
     *      href="http://www.selenic.com/mercurial/hg.1.html#qdiff">Mercurial
     *      documentation</a>
     * @return this instance
     */
    public QDiffCommand ignoreAllSpace() {
        cmdAppend("--ignore-all-space");
        return (QDiffCommand) this;
    }

    /**
     * Set the <tt>--ignore-space-change</tt> command line flag.
     * 
     * @see <a
     *      href="http://www.selenic.com/mercurial/hg.1.html#qdiff">Mercurial
     *      documentation</a>
     * @return this instance
     */
    public QDiffCommand ignoreSpaceChange() {
        cmdAppend("--ignore-space-change");
        return (QDiffCommand) this;
    }

    /**
     * Set the <tt>--ignore-blank-lines</tt> command line flag.
     * 
     * @see <a
     *      href="http://www.selenic.com/mercurial/hg.1.html#qdiff">Mercurial
     *      documentation</a>
     * @return this instance
     */
    public QDiffCommand ignoreBlankLines() {
        cmdAppend("--ignore-blank-lines");
        return (QDiffCommand) this;
    }

    /**
     * Set the <tt>--unified</tt> command line flag.
     * 
     * @see <a
     *      href="http://www.selenic.com/mercurial/hg.1.html#qdiff">Mercurial
     *      documentation</a>
     * @return this instance
     */
    public QDiffCommand unified(String num) {
        cmdAppend("--unified", num);
        return (QDiffCommand) this;
    }

    /**
     * Set the <tt>--stat</tt> command line flag.
     * 
     * @see <a
     *      href="http://www.selenic.com/mercurial/hg.1.html#qdiff">Mercurial
     *      documentation</a>
     * @return this instance
     */
    public QDiffCommand stat() {
        cmdAppend("--stat");
        return (QDiffCommand) this;
    }

    /**
     * Set the <tt>--include</tt> command line flag.
     * 
     * @see <a
     *      href="http://www.selenic.com/mercurial/hg.1.html#qdiff">Mercurial
     *      documentation</a>
     * @return this instance
     */
    public QDiffCommand include(String... patterns) {
        cmdAppend("--include", patterns);
        return (QDiffCommand) this;
    }

    /**
     * Set the <tt>--exclude</tt> command line flag.
     * 
     * @see <a
     *      href="http://www.selenic.com/mercurial/hg.1.html#qdiff">Mercurial
     *      documentation</a>
     * @return this instance
     */
    public QDiffCommand exclude(String... patterns) {
        cmdAppend("--exclude", patterns);
        return (QDiffCommand) this;
    }

}
