/*
 * #%L
 * JavaHg
 * %%
 * Copyright (C) 2011 aragost Trifork ag
 * %%
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 * #L%
 */

/*
 * Automatically generated based on Mercurial 2.1.1+41-63a1bed65fa3.
 *
 * Don't edit this file! Edit scripts/generate-flag-classes.py instead.
 */
package com.aragost.javahg.ext.mq.flags;

import com.aragost.javahg.Repository;
import com.aragost.javahg.ext.mq.StripCommand;
import com.aragost.javahg.internals.AbstractCommand;

public abstract class StripCommandFlags extends AbstractCommand {

    protected StripCommandFlags(Repository repository) {
        super(repository);
    }

    @Override
    public final String getCommandName() {
        return "strip";
    }

    public static StripCommand on(Repository repository) {
        return new StripCommand(repository);
    }

    /**
     * Set the <tt>--rev</tt> command line flag.
     * 
     * @see <a
     *      href="http://www.selenic.com/mercurial/hg.1.html#strip">Mercurial
     *      documentation</a>
     * @return this instance
     */
    public StripCommand rev(String... revs) {
        cmdAppend("--rev", revs);
        return (StripCommand) this;
    }

    /**
     * Set the <tt>--force</tt> command line flag.
     * 
     * @see <a
     *      href="http://www.selenic.com/mercurial/hg.1.html#strip">Mercurial
     *      documentation</a>
     * @return this instance
     */
    public StripCommand force() {
        cmdAppend("--force");
        return (StripCommand) this;
    }

    /**
     * Set the <tt>--backup</tt> command line flag.
     * 
     * @deprecated Using this flag has been deprecated in Mercurial.
     *             The flag wont go away, but there will typically be
     *             a better way to express the same thing.
     * @see <a
     *      href="http://www.selenic.com/mercurial/hg.1.html#strip">Mercurial
     *      documentation</a>
     * @return this instance
     */
    @Deprecated
    public StripCommand backup() {
        cmdAppend("--backup");
        return (StripCommand) this;
    }

    /**
     * Set the <tt>--no-backup</tt> command line flag.
     * 
     * @see <a
     *      href="http://www.selenic.com/mercurial/hg.1.html#strip">Mercurial
     *      documentation</a>
     * @return this instance
     */
    public StripCommand noBackup() {
        cmdAppend("--no-backup");
        return (StripCommand) this;
    }

    /**
     * Set the <tt>--nobackup</tt> command line flag.
     * 
     * @deprecated Using this flag has been deprecated in Mercurial.
     *             The flag wont go away, but there will typically be
     *             a better way to express the same thing.
     * @see <a
     *      href="http://www.selenic.com/mercurial/hg.1.html#strip">Mercurial
     *      documentation</a>
     * @return this instance
     */
    @Deprecated
    public StripCommand nobackup() {
        cmdAppend("--nobackup");
        return (StripCommand) this;
    }

    /**
     * Set the <tt>--keep</tt> command line flag.
     * 
     * @see <a
     *      href="http://www.selenic.com/mercurial/hg.1.html#strip">Mercurial
     *      documentation</a>
     * @return this instance
     */
    public StripCommand keep() {
        cmdAppend("--keep");
        return (StripCommand) this;
    }

}
